--- certified-asterisk-11.2-cert1/channels/chan_sip.c   2013-03-27 16:24:42.000000000 +0100
+++ patched-certified-asterisk-11.2-cert1/channels/chan_sip.c   2013-04-18 21:25:27.000000000 +0200
@@ -16744,6 +16744,29 @@
                name = domain;
        }
 
+       if (global_match_auth_username) {
+               /*
+                * XXX This is experimental code to grab the search key from the
+                * Auth header's username instead of the 'From' name, if available.
+                * Do not enable this block unless you understand the side effects (if any!)
+                * Note, the search for "username" should be done in a more robust way.
+                * Note2, at the moment we check both fields, though maybe we should
+                * pick one or another depending on the request ? XXX
+                */
+               const char *hdr = sip_get_header(req, "Authorization");
+               if (ast_strlen_zero(hdr)) {
+                       hdr = sip_get_header(req, "Proxy-Authorization");
+               }
+               ast_log(LOG_DEBUG, "Do match auth username, got auth header: %s\n", hdr);
+               if (!ast_strlen_zero(hdr) && (hdr = strstr(hdr, "username=\""))) {
+                       char from[256] = "";
+                       ast_copy_string(from, hdr + strlen("username=\""), sizeof(from));
+                       name = from;
+                       name = strsep(&name, "\"");
+                       ast_log(LOG_DEBUG, "Do match auth username, got username: %s\n", name);
+               }
+       }
+
        /* This here differs from 1.4 and 1.6: the domain matching ACLs were
         * skipped if it was a domain-only URI (used as username). Here we treat
         * <sip:hostport> as <sip:host@hostport> and won't forget to test the
@@ -18218,11 +18241,12 @@
                if (ast_strlen_zero(hdr)) {
                        hdr = sip_get_header(req, "Proxy-Authorization");
                }
-
+               ast_log(LOG_DEBUG, "Do match auth username, got auth header: %s\n", hdr);
                if (!ast_strlen_zero(hdr) && (hdr = strstr(hdr, "username=\""))) {
                        ast_copy_string(from, hdr + strlen("username=\""), sizeof(from));
                        name = from;
                        name = strsep(&name, "\"");
+                       ast_log(LOG_DEBUG, "Do match auth username, got username: %s\n", name);
                }
        }
